var assert, csv;
csv = require('csv');
assert = require('assert');
module.exports = {
  call: function(client, procedure, args, callback) {
    var body, headers, key, request, value;
    body = ((function() {
      var _results;
      _results = [];
      for (key in args) {
        value = args[key];
        _results.push([escape(key), escape(value)].join("\t"));
      }
      return _results;
    })()).join("\n");
    headers = {
      'Connection': 'keep-alive',
      'Content-Length': body.length,
      'Content-Type': 'text/tab-separated-values; colenc=U'
    };
    request = client.request('POST', "/rpc/" + procedure, headers);
    request.end(body);
    return request.on('response', function(response) {
      var colenc, content_type, data, tsv, _ref;
      data = {};
      tsv = csv().fromStream(response, {
        delimiter: "\t",
        escape: "",
        encoding: 'ascii'
      }).on('data', function(row, index) {
        assert.ok(row.length >= 2);
        return data[row[0]] = row[1];
      });
      _ref = response.headers['content-type'].split('; '), content_type = _ref[0], colenc = _ref[1];
      assert.ok(content_type === "text/tab-separated-values", "response not in expected TSV format");
      if (colenc != null) {
        colenc = colenc.substr(-1, 1);
      }
      switch (colenc) {
        case 'U':
          tsv.transform(function(row, index) {
            var col, _i, _len, _results;
            _results = [];
            for (_i = 0, _len = row.length; _i < _len; _i++) {
              col = row[_i];
              _results.push(unescape(col));
            }
            return _results;
          });
          break;
        case 'B':
          throw new Error("Base64 encoding is not implemented");
      }
      return response.on('end', function() {
        return callback(void 0, response.statusCode, data);
      });
    });
  }
};